<?php $page="Add Floor";
    include"header.php";?>
<?php
    header("Expires: on, 01 Jan 1970 00:00:00 GMT");
    header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
    header("Cache-Control: no-store, no-cache, must-revalidate");
    header("Cache-Control: post-check=0, pre-check=0", false);
    header("Pragma: no-cache");
    include_once('includes/crud.php');
    include_once('includes/functions.php');
    include_once('includes/custom-functions.php');
    
    $fn = new custom_functions;
    $permissions = $fn->get_permissions($_SESSION['id']);
    $db = new Database();
    $db->connect();
    
        
        if(isset($_POST['btnAdd'])){
           
			if($permissions['locations']['create']==1){
			$floor_name = $db->escapeString($fn->xss_clean($_POST['floor_name']));
			$block_id = $db->escapeString($fn->xss_clean($_POST['block_id']));
			
			// create array variable to handle error
			$error = array();
			
			if(empty($floor_name)){
				$error['floor_name'] = " <span class='label label-danger'>Floor Name Required!</span>";
			}
				
			if(empty($block_id) || $block_id == '' ){
				$error['block_id'] = " <span class='label label-danger'>Block Required!</span>";
			}
				
				
				if(!empty($floor_name) && !empty($block_id) ){
				    
				    // Validate Already Exist
				   
			        $db->select('floor','*',null,'name="'.$floor_name.'" AND block_id='.$block_id);
					$floor = $db->getResult();
					
				    if(!empty($floor)){
				        $error['add_floor'] = "<div class='content-header'>
    												<span class='label label-danger'>Floor Already Exist</span>
    												<h4><small><a  href='floors.php'><i class='fa fa-angle-double-left'></i>&nbsp;&nbsp;&nbsp;Back to Floors</a></small></h4>
    												
    												</div>";
				    }else{
				    
				    //Insert floor
				    $data = array(
        			    'name' => $floor_name,
        			    'block_id' => $block_id,
				    );
    				$db->insert('floor',$data);
			        $res = $db->getResult();
    				if($res){
    					$error['add_floor'] = "<div class='content-header'>
    												<span class='label label-success'>Floor Added Successfully</span>
    												<h4><small><a  href='floors.php'><i class='fa fa-angle-double-left'></i>&nbsp;&nbsp;&nbsp;Back to Floors</a></small></h4>
    												
    												</div>";
    				}else {
    					$error['add_floor'] = " <span class='label label-danger'>Failed</span>";
    				}
			    }
				}
			
		    }else{
			    $error['add_floor'] = "<div class='content-header'>
					<span class='label label-danger'>You have no permission to create Floor</span>
					</div>";

			}
		}
?>
        <div class='row'>
            <div class='col-md-8'>
                <?php echo isset($error['add_floor']) ? $error['add_floor'] : '';?>
                <?php if($permissions['locations']['create']==0){?>
		  		<div class="alert alert-danger">You have no permission to create Floor</div>
		  	    <?php } ?>
		  	    <div class="box box-primary">
                    <div class="box-header with-border">
                      <h3 class="box-title">Add Floor</h3>
                    </div>
                    <form  method="post" enctype="multipart/form-data">
                    <div class="box-body">
                        <div class='row'>
                            <div class='col-md-6 form-group'>
                                <label class="control-label">City</label>
                                <select name="city_id" id="city_id" class="form-control">
                                   <option value=''>All</option>
                                   <?php
        
                                    $sql = "SELECT * FROM `city` ORDER BY `id` ASC";
                                    $db->sql($sql);
                                    $res_city = $db->getResult();
                                    
                                    foreach($res_city as $c){ ?>
                                    <option value='<?=$c['id']?>'><?=$c['name']?></option>
                                    
                                  <?php }?>
                                </select>
                            </div>
                            <div class='col-md-6 form-group'>
                                <label class="control-label">Area</label>
                                <select name="area_id" id="area_id" class="form-control">
                                   <option value=''>All</option>
                                    
                                    } ?>
                                </select>
                            </div>
                            <div class='col-md-6 form-group'>
                                <label class="control-label">Building</label>
                                <select name="building_id" id="building_id" class="form-control">
                                   <option value=''>All</option>
                                    
                                </select>
                            </div>
                            
                            <div class='col-md-6 form-group'>
                                <label class="control-label">Block</label>
                                <select name="block_id" id="block_id" class="form-control">
                                   <option value=''>All</option>
                                </select>
                                <?php echo isset($error['block_id']) ? $error['block_id'] : '';?>
                            </div>
                        </div>
                        <br>
                        <div class="form-group">
                          <label class="control-label">Floor Name</label><?php echo isset($error['floor_name']) ? $error['floor_name'] : '';?>
                          <input type="text" class="form-control"  name="floor_name" required/>
                        </div>
                    </div>
                   
                    <div class="box-footer text-center">
                        <input type="submit" class="btn-primary btn" value="Add" name="btnAdd"/>&nbsp;
    					<input type="reset" class="btn-danger btn" value="Clear"/>
                    </div>
                </div> 
                </form>
            </div>
        </div>
                   
  
<?php include"footer.php";?>
<!-- jQuery -->

<script>

   
    city_id = '<?=isset($_GET['city_id']) ? $db->escapeString($_GET['city_id']):'' ?>';
    building_id = '<?=isset($_GET['building_id']) ? $db->escapeString($_GET['building_id']):'' ?>';
    $('#city_id').val(city_id).trigger("change",[city_id,building_id]);
    $('#building_id').val(building_id);
   
    $('#state_id').on('change',function(e,state_id,city_id){
        var state_id = $('#state_id').val();
        $.ajax({
          url:"public/db-operation.php",
          data:"state_id="+state_id+"&find_city=1",
           method:"POST",
           success:function(data){
               $('#city_id').html(data);
               $('#city_id').val(city_id);
           }
        });
    });
    
    $('#city_id').on('change',function(e,city_id,area_id){
        var city_id = $('#city_id').val();
        $.ajax({
          url:"public/db-operation.php",
          data:"city_id="+city_id+"&find_area=1",
           method:"POST",
           success:function(data){
               $('#area_id').html(data);
               $('#area_id').val(area_id);
           }
        });
    });
    
    
    $('#area_id').on('change',function(e,area_id,building_id){
        var area_id = $('#area_id').val();
        $.ajax({
          url:"public/db-operation.php",
          data:"area_id="+area_id+"&find_building=1",
           method:"POST",
           success:function(data){
               $('#building_id').html(data);
               $('#building_id').val(building_id);
           }
        });
    });
    
    $('#building_id').on('change',function(e,building_id,block_id){
        var building_id = $('#building_id').val();
        $.ajax({
          url:"public/db-operation.php",
          data:"building_id="+building_id+"&find_block=1",
           method:"POST",
           success:function(data){
               $('#block_id').html(data);
               $('#block_id').val(block_id);
           }
        });
    });
    
</script>
