<?php $page="Add Unit";
    include"header.php";?>
<?php
    header("Expires: on, 01 Jan 1970 00:00:00 GMT");
    header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
    header("Cache-Control: no-store, no-cache, must-revalidate");
    header("Cache-Control: post-check=0, pre-check=0", false);
    header("Pragma: no-cache");
    include_once('includes/crud.php');
    include_once('includes/functions.php');
    include_once('includes/custom-functions.php');
    
    $fn = new custom_functions;
    $permissions = $fn->get_permissions($_SESSION['id']);
    $db = new Database();
    $db->connect();
    
        
        if(isset($_POST['btnAdd'])){
           
			if($permissions['locations']['create']==1){
			$unit_name = $db->escapeString($fn->xss_clean($_POST['unit_name']));
			$short_code = $db->escapeString($fn->xss_clean($_POST['short_code']));
			
			// create array variable to handle error
			$error = array();
			
			if(empty($unit_name)){
				$error['unit_name'] = " <span class='label label-danger'>Unit Name Required!</span>";
			}
				
			if(empty($short_code)){
				$error['short_code'] = " <span class='label label-danger'>Unit Short Code Required!</span>";
			}
				
				
				if(!empty($unit_name) && !empty($short_code) ){
				    
				    // Validate Already Exist
				   
			        $db->select('unit','*',null,'name="'.$unit_name.'" AND short_code="'.$short_code.'"');
					$unit = $db->getResult();
					
				    if(!empty($unit)){
				        $error['add_unit'] = "<div class='content-header'>
    												<span class='label label-danger'>Unit Already Exist</span>
    												<h4><small><a  href='units.php'><i class='fa fa-angle-double-left'></i>&nbsp;&nbsp;&nbsp;Back to Units</a></small></h4>
    												
    												</div>";
				    }else{
				    
				    $parent_id = $db->escapeString($fn->xss_clean($_POST['parent_id']));
				    $conversion = $db->escapeString($fn->xss_clean($_POST['conversion']));
				    //Insert unit
				    $data = array(
        			    'name' => $unit_name,
        			    'short_code' => $short_code,
        			    'parent_id'=>$parent_id,
        			    'conversion'=>$conversion
				    );
    				$db->insert('unit',$data);
			        $res = $db->getResult();
    				if($res){
    					$error['add_unit'] = "<div class='content-header'>
    												<span class='label label-success'>Unit Added Successfully</span>
    												<h4><small><a  href='units.php'><i class='fa fa-angle-double-left'></i>&nbsp;&nbsp;&nbsp;Back to Units</a></small></h4>
    												
    												</div>";
    				}else {
    					$error['add_unit'] = " <span class='label label-danger'>Failed</span>";
    				}
			    }
				}
			
		    }else{
			    $error['add_unit'] = "<div class='content-header'>
					<span class='label label-danger'>You have no permission to create Unit</span>
					</div>";

			}
		}
?>
        <div class='row'>
            <div class='col-md-8'>
                <?php echo isset($error['add_unit']) ? $error['add_unit'] : '';?>
                <?php if($permissions['locations']['create']==0){?>
		  		<div class="alert alert-danger">You have no permission to create Unit</div>
		  	    <?php } ?>
		  	    <div class="box box-primary">
                    <div class="box-header with-border">
                      <h3 class="box-title">Add unit</h3>
                    </div>
                    <form  method="post" enctype="multipart/form-data">
                    <div class="box-body">
                        <div class='row'>
                            <div class='col-md-6 form-group'>
                                <div class="form-group">
                                  <label class="control-label">Unit Name</label><?php echo isset($error['unit_name']) ? $error['unit_name'] : '';?>
                                  <input type="text" class="form-control"  name="unit_name" required/>
                                </div>
                            </div>
                            <div class='col-md-6 form-group'>
                                <div class="form-group">
                                  <label class="control-label">Unit Short Code</label><?php echo isset($error['short_code']) ? $error['short_code'] : '';?>
                                  <input type="text" class="form-control"  name="short_code" required/>
                                </div>
                            </div>
                        </div>
                        <div class='row'>
                            <div class='col-md-6 form-group'>
                                <label class="control-label">Parent Unit(optional)</label>
                                <select name="parent_id"  class="form-control">
                                   <option value=''>All</option>
                                   <?php
        
                                    $sql = "SELECT * FROM `unit` ORDER BY `id` ASC";
                                    $db->sql($sql);
                                    $res_unit = $db->getResult();
                                    
                                    foreach($res_unit as $u){ ?>
                                    <option value='<?=$u['id']?>'><?=$u['short_code']?></option>
                                    
                                  <?php }?>
                                </select>
                            </div>
                            <div class='col-md-6 form-group'>
                                <div class="form-group">
                                  <label class="control-label">Conversion(optional)</label>
                                  <input type="text" class="form-control"  name="conversion" />
                                </div>
                            </div>
                        </div>
                    </div>
                   
                    <div class="box-footer text-center">
                        <input type="submit" class="btn-primary btn" value="Add" name="btnAdd"/>&nbsp;
    					<input type="reset" class="btn-danger btn" value="Clear"/>
                    </div>
                </div> 
                </form>
            </div>
        </div>
                   
  
<?php include"footer.php";?>
<!-- jQuery -->

<script>

   
    city_id = '<?=isset($_GET['city_id']) ? $db->escapeString($_GET['city_id']):'' ?>';
    building_id = '<?=isset($_GET['building_id']) ? $db->escapeString($_GET['building_id']):'' ?>';
    $('#city_id').val(city_id).trigger("change",[city_id,building_id]);
    $('#building_id').val(building_id);
   
    $('#state_id').on('change',function(e,state_id,city_id){
        var state_id = $('#state_id').val();
        $.ajax({
          url:"public/db-operation.php",
          data:"state_id="+state_id+"&find_city=1",
           method:"POST",
           success:function(data){
               $('#city_id').html(data);
               $('#city_id').val(city_id);
           }
        });
    });
    
    $('#city_id').on('change',function(e,city_id,area_id){
        var city_id = $('#city_id').val();
        $.ajax({
          url:"public/db-operation.php",
          data:"city_id="+city_id+"&find_area=1",
           method:"POST",
           success:function(data){
               $('#area_id').html(data);
               $('#area_id').val(area_id);
           }
        });
    });
    
    
    $('#area_id').on('change',function(e,city_id,building_id){
        var area_id = $('#area_id').val();
        $.ajax({
          url:"public/db-operation.php",
          data:"area_id="+area_id+"&find_building=1",
           method:"POST",
           success:function(data){
               $('#building_id').html(data);
               $('#building_id').val(building_id);
           }
        });
    });
    
</script>
