<?php 
header('Access-Control-Allow-Origin: *');
session_start();
include '../includes/crud.php';
include '../includes/custom-functions.php';
$fn = new custom_functions;
$permissions = $fn->get_permissions($_SESSION['id']);
include '../includes/variables.php';
include_once('verify-token.php');
$db=new Database();
$db->connect();
$fn = new custom_functions();
$settings = $fn->get_settings('system_timezone',true);
$app_name = $settings['app_name'];
include 'send-email.php';
include 'send-sms.php';

$response = array();
$accesskey = $_POST['accesskey'];
// echo $access_key;

if($access_key != $accesskey){
	$response['error']= true;
	$response['message']="invalid accesskey";
	print_r(json_encode($response));
	return false;
}


if ((isset($_POST['type'])) && ($_POST['type'] == 'list_address')) {
    $user_id = $db->escapeString($_POST['user_id']);
    
    $sql = 'select u.*, (SELECT name FROM area a WHERE a.id=u.area) as area_name,(SELECT name FROM city c WHERE c.id=u.city) as city_name,(SELECT name FROM building b WHERE b.id=u.building) as building_name,(SELECT name FROM block bl WHERE bl.id=u.block) as block_name,(SELECT name FROM floor f WHERE f.id=u.floor) as floor_name,(SELECT name FROM door d WHERE d.id=u.door) as door_name from user_address u where user_id ='.$user_id;
    
   // $sql = 'select u.*, (SELECT name FROM city c WHERE c.id=u.city) AS city_name, IFNULL((SELECT name FROM area a WHERE a.id=u.area) , "")  AS area_name from user_address u where user_id ='.$user_id;
    
    $db->sql($sql);
    $res = $db->getResult();
	if($res){
	   
		$response["error"]   = false;
		$response['data'] = $res;
		print_r(json_encode($response));
	    return false;
	}else{
	    $response["error"]   = true;
		$response['data'] = array();
		print_r(json_encode($response));
	    return false;
	}
}

if ((isset($_POST['type'])) && ($_POST['type'] == 'add_address')) {
    $user_id = $db->escapeString($_POST['user_id']);
    $name 		= (isset($_POST['name']))?$db->escapeString($_POST['name']):"";
    $mobile 		= (isset($_POST['mobile']))?$db->escapeString($_POST['mobile']):"";
    $city 		= (isset($_POST['city_id']))?$db->escapeString($_POST['city_id']):"";
    $area 		= (isset($_POST['area_id']))?$db->escapeString($_POST['area_id']):"";
    $building 		= (isset($_POST['building_id']))?$db->escapeString($_POST['building_id']):"";
    $block 		= (isset($_POST['block_id']))?$db->escapeString($_POST['block_id']):"";
    $floor 		= (isset($_POST['floor_id']))?$db->escapeString($_POST['floor_id']):"";
    $door 		= (isset($_POST['door_id']))?$db->escapeString($_POST['door_id']):"";
    $landmark 		= (isset($_POST['landmark']))?$db->escapeString($_POST['landmark']):"";
    $flat_no 		= (isset($_POST['flat_no']))?$db->escapeString($_POST['flat_no']):"";
	$street 	= (isset($_POST['street']))?$db->escapeString($_POST['street']):"";
	$address 	= (isset($_POST['address']))?$db->escapeString($_POST['address']):"";
	$pincode 	= (isset($_POST['pincode']))?$db->escapeString($_POST['pincode']):"";
	$latitude 	= (isset($_POST['latitude']))?$db->escapeString($_POST['latitude']):"0";
	$longitude 	= (isset($_POST['longitude']))?$db->escapeString($_POST['longitude']):"0";
	$data = array(
		'name' => $name,
	    'mobile' => $mobile,
	    'user_id' => $user_id,
	    'city' => $city,
	    'area' => $area,
	    'building' => $building,
		'block' => $area,
		'floor' => $block,
	    'door' => $door,
	    'landmark' => $landmark,
	    'flat_no' => $flat_no,
	    'street' => $street,
		'address' => $address,
	    'pincode' => $pincode,
	    'latitude' => $latitude,
	    'longitude' => $longitude,
	    'is_default' => 0,
	    'status' => 1
	);
	$db->insert('user_address',$data);
	$response["error"]   = false;
	$response["message"] = "Address Added successfully";
	print_r(json_encode($response));
    return false;
}
if ((isset($_POST['type'])) && ($_POST['type'] == 'edit_address')) {
    $user_id = $db->escapeString($_POST['user_id']);
    $id = $db->escapeString($_POST['id']);
    $sql = 'select u.*,(SELECT name FROM city c WHERE c.id=u.city) AS city_name, (SELECT name FROM area a WHERE a.id=u.area) AS area_name ,(SELECT name FROM building b WHERE b.id=u.building) as building_name,(SELECT name FROM block bl WHERE bl.id=u.block) as block_name,(SELECT name FROM floor f WHERE f.id=u.floor) as floor_name,(SELECT name FROM door d WHERE d.id=u.door) as door_name from user_address u where u.user_id ='.$user_id.' AND u.id='.$id;
    $db->sql($sql);
    $res = $db->getResult();
	if($res){
		$response["error"]   = false;
		//$response["message"] = "Invitation sent successfully";
		$response['data'] = $res[0];
		print_r(json_encode($response));
	    return false;
	}
}

if ((isset($_POST['type'])) && ($_POST['type'] == 'update_address')) {
    $user_id = $db->escapeString($_POST['user_id']);
    $id = $db->escapeString($_POST['id']);
    $name 		= (isset($_POST['name']))?$db->escapeString($_POST['name']):"";
    $mobile 		= (isset($_POST['mobile']))?$db->escapeString($_POST['mobile']):"";
    $city 		= (isset($_POST['city_id']))?$db->escapeString($_POST['city_id']):"";
    $area 		= (isset($_POST['area_id']))?$db->escapeString($_POST['area_id']):"";
    $building 		= (isset($_POST['building_id']))?$db->escapeString($_POST['building_id']):"";
    $block 		= (isset($_POST['block_id']))?$db->escapeString($_POST['block_id']):"";
    $floor 		= (isset($_POST['floor_id']))?$db->escapeString($_POST['floor_id']):"";
    $door 		= (isset($_POST['door_id']))?$db->escapeString($_POST['door_id']):"";
    $landmark 		= (isset($_POST['landmark']))?$db->escapeString($_POST['landmark']):"";
    $flat_no 		= (isset($_POST['flat_no']))?$db->escapeString($_POST['flat_no']):"";
	$street 	= (isset($_POST['street']))?$db->escapeString($_POST['street']):"";
	$address 	= (isset($_POST['address']))?$db->escapeString($_POST['address']):"";
	$pincode 	= (isset($_POST['pincode']))?$db->escapeString($_POST['pincode']):"";
	$latitude 	= (isset($_POST['latitude']))?$db->escapeString($_POST['latitude']):"0";
	$longitude 	= (isset($_POST['longitude']))?$db->escapeString($_POST['longitude']):"0";
	$data = array(
	    'name' => $name,
	    'mobile' => $mobile,
	    'city' => $city,
	    'area' => $area,
	    'building' => $building,
		'block' => $area,
		'floor' => $block,
	    'door' => $door,
	    'landmark' => $landmark,
	    'flat_no' => $flat_no,
	    'street' => $street,
	    'address' => $address,
	    'pincode' => $pincode,
	    'latitude' => $latitude,
	    'longitude' => $longitude,
	    'is_default' => 0,
	    'status' => 1
	);
//	$fp = fopen('g.txt', 'a');fwrite($fp,json_encode($_POST).PHP_EOL);fclose($fp);
	$db->update('user_address',$data,'id='.$id);
	$response["error"]   = false;
	$response["message"] = "Address Updated successfully";
	print_r(json_encode($response));
    return false;
}

if ((isset($_POST['type'])) && ($_POST['type'] == 'delete_address')) {
    $user_id = $db->escapeString($_POST['user_id']);
    $id = $db->escapeString($_POST['id']);
    $sql = 'DELETE FROM user_address WHERE user_id ='.$user_id.' AND id='.$id;
    $db->sql($sql);
    $res = $db->getResult();
	if($res){
		$response["error"]   = false;
		$response["message"] = "Address Deleted successfully";
		print_r(json_encode($response));
	    return false;
	}else{
	    $response["error"]   = false;
		$response["message"] = "Address Deleted successfully";
		print_r(json_encode($response));
	    return false;
	}
}

?>